//In the name of God
#include <iostream>
#include <algorithm>
using namespace std;

#define num unsigned long long
num gcd(num a,num b)
{
  if(b==0)
    return a;
  if(a%b==0)
    return b;
  return gcd(b,a%b);
}

struct frac
{
  num up,down;
  frac()
  {
    up=0; down=1;
  }
  void make()
  {
    num g=gcd(up,down);
    up/=g;
    down/=g;
  }
  frac(num a,num b)
  {
    up=a;
    down=b;
    make();
  }
};

frac operator + (frac a,frac b)
{
  num gc=gcd(a.down,b.down);
  num lc=a.down/gc*b.down;
  frac ans(a.up*(lc/a.down)+b.up*(lc/b.down),lc);
  return ans;
}


int front[7]={-1,2,1,4,3,6,5};
frac has[7][2];

int main()
{
  for(int i=1;i<=6;++i)
    has[i][0].up=i;
  for(int step=1;step<=50;++step)
    {
      cout<<"step:"<<step<<endl;
    for(int i=1;i<=6;++i)
      {
	has[i][step%2].up=0; has[i][step%2].down=1;
	for(int j=1;j<=6;++j)
	  if(j!=i and j!=front[i])
	    {
	      frac temp=has[j][1-step%2];
	      temp.down*=4; temp.make();
	      has[i][step%2]=has[i][step%2]+temp;
	    }
	cout<<i<<":"<<has[i][step%2].up<<" "<<has[i][step%2].down<<endl;
      }
    }
  return 0;
}
