//In the name of God
#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>
using namespace std;

const int MOD=13922013;

#define num long long
num gcd(num a,num b)
{
  if(b==0)
    return a;
  if(a%b==0)
    return b;
  return gcd(b,a%b);
}

struct frac
{
  num up,down;
  frac()
  {
    up=0; down=1;
  }
  void make()
  {
    num g=gcd(abs(up),abs(down));
    up/=g;
    down/=g;
    if(up<0 and down<0)
      {up=-up; down=-down;}
    else if(up<0 or down<0)
      {up=-abs(up); down=abs(down);}
  }
  frac(num a,num b)
  {
    up=a;
    down=b;
    make();
  }
};

bool operator < (frac a,frac b)
{return make_pair(a.up,a.down)<make_pair(b.up,b.down);}

#define point pair<int,int>
#define x first
#define y second
#define MAXN 10000

map<frac,int> cnt;

num add(num g)
{
  num ans=1;
  for(int i=0;i<4;++i)
    {
      ans*=(g-i);
      ans%=MOD;
    }
  return ans;
}

int main()
{
  num ans=0;
  vector<point> all;
  for(int i=1;i<=MAXN;++i)
    {
      point t;
      cin>>t.x>>t.y;
      all.push_back(t);
    }
  int inf=0;
  for(int i=0;i<all.size();++i,inf=0,cnt.erase(cnt.begin(),cnt.end()))
    {
      cerr<<"i:"<<i<<endl;
    for(int j=0;j<all.size();++j)
      if(i==j)
	continue;
      else
	{
	  num dx=all[i].x-all[j].x;
	  num dy=all[i].y-all[j].y;
	  if(dy==0)
	    inf++;
	  else
	    {
	      frac m(dx,dy);
	      cnt[m]++;
	    }
	}
    ans+=add(inf); ans%=MOD;
    for(map<frac,int>::iterator i=cnt.begin();i!=cnt.end();++i)
      {ans+=add(i->y); ans%=MOD;}
    }
  cout<<fixed<<ans<<endl;
  return 0;
}
