//Code #1
#include <cstdio>
#include <vector>
using namespace std;
// 0110100110010110
// 0 - 0
// 1 - 1
// 01 - 0
// 10 - 2
// 010 - 3
// 101 - 2
// 0101 - 10
// 1010 - 2

int p[4][2] = { {0,1}, {0,2}, {3,2}, {10,2} };

vector<vector<int> > s;
int code;
bool insert(int i, int val)
{
    s[i].push_back(val);
    int t = s[i].size();
    if(i<s.size()-1)
    {
        if((t+(code>>i))&1)
            return insert(i+1,val);
        return (val==s[i+1].back());
    }
    if(t>1 && s[i][t-1]==s[i][t-2])
    {
        s.push_back(vector<int>());
        if(t%2==0)
            code |= 1<<i;
        for(int j=0;j<t-1;j+=2)
            if(insert(i+1, s[i][j] == (t&1)))
                return true;
        return insert(i+1,val);
    }
    return false;
}
void tst()
{
    int n;
    scanf("%d",&n);
    s.clear();
    code = 0;
    bool wrong = false;
    s.push_back(vector<int>());
    for(int it=0;it<n;it++)
    {
        int x;
        scanf("%d",&x);
        if(wrong)
        {
            printf("-1 ");
            continue;
        }
        
        wrong = insert(0, x);

        if(s.back().size()>4)
            wrong = true;

        if(wrong)
        {
            printf("-1 ");
        }
        else
        {
            printf("%d ",code + (p[s.back().size()-1][s.back()[0]]<<(s.size()-1)));
        }
    }
    puts("");
}

int main()
{
    int t;
    scanf("%d",&t);
    for(;t--;)
        tst();
}

//end of code
//code #2
#include <iostream>
#include <cmath>
#include <cassert>
using namespace std;

#define FOR(i,a,b) for (int i=a; i<=b; ++i)
#define int64 long long

#define INF ((1<<31) - 1)
#define MAX 32000

int n, k;

int power(int a, int n, int m) {
	if (n==0) return 1%m;
	if (n%2==0) {
		int t=power(a,n/2,m);
		return ((int64) t*t)%m;
	}
	return ((int64) a*power(a,n-1,m))%m;
}

int main() {
//	freopen("power.in", "r", stdin);
//	freopen("power.out", "w", stdout);
	int _t; scanf ("%d", &_t);
	while(_t--) {
		scanf("%d%d", &n, &k);
		if (n==0 && k==0) break;
		
		double lognn = n * log10((double)n);
		int nDigit = (int)floor(lognn) + 1;
		
		assert(1<=k && k<=nDigit);
		
		int pow10k=1;
		FOR(i,1,k) pow10k*=10;		
		
		int lastK=power(n,n,pow10k);		
		
		int firstK=0;
		FOR(i,1,k) 
			FOR(d,0,9) {
				if (lognn-(nDigit-i)<log10((double)firstK*10+d+1)) {
					firstK=firstK*10+d;
					break;
				}				
			}		
		
		printf("%d", firstK);
		int nMissing=lastK==0?k:k-floor(log10((double)lastK))-1;
		FOR(i,1,nMissing) printf("0");
		printf("%d\n", lastK);		
	}
	return 0;
}

//end of code
//CODE #3
#include <iostream>
#include <cmath>
#include <cassert>
using namespace std;

#define FOR(i,a,b) for (int i=a; i<=b; ++i)
#define int64 long long

#define INF ((1<<31) - 1)
#define MAX 32000

int n, k;

int power(int a, int n, int m) {
	if (n==0) return 1%m;
	if (n%2==0) {
		int t=power(a,n/2,m);
		return ((int64) t*t)%m;
	}
	return ((int64) a*power(a,n-1,m))%m;
}

int main() {
//	freopen("power.in", "r", stdin);
//	freopen("power.out", "w", stdout);
	int _t; scanf ("%d", &_t);
	while(_t--) {
		scanf("%d%d", &n, &k);
		if (n==0 && k==0) break;
		
		double lognn = n * log10((double)n);
		int nDigit = (int)floor(lognn) + 1;
		
		assert(1<=k && k<=nDigit);
		
		int pow10k=1;
		FOR(i,1,k) pow10k*=10;		
		
		int lastK=power(n,n,pow10k);		
		
		int firstK=0;
		FOR(i,1,k) 
			FOR(d,0,9) {
				if (lognn-(nDigit-i)<log10((double)firstK*10+d+1)) {
					firstK=firstK*10+d;
					break;
				}				
			}		
		
		printf("%d ", firstK);
		int nMissing=lastK==0?k:k-floor(log10((double)lastK))-1;
		FOR(i,1,nMissing) printf("0");
		printf("%d\n", lastK);		
	}
	return 0;
}

//end of code

#include <hello>

//end of coDE
#include <iostream>
#include <vector>
#include <ext/hash_map>

using namespace std;
using namespace __gnu_cxx;

typedef unsigned int uint;

hash_map<uint, int> maxDollars;


int
getValueInMap(uint bc)
{
    if (maxDollars.find(bc) == maxDollars.end())
    {
	return -1;
    }
    else
    {
	return maxDollars[bc];
    }
}

uint
getMaxDollars(uint bc)
{
    if (bc <= 1)
    {
	return bc;
    }

    if (getValueInMap(bc) != -1)
    {
	return getValueInMap(bc);
    }

    uint f1, f2, f3;
    f1 = bc/2;
    f2 = bc/3;
    f3 = bc/4;

    f1 = getMaxDollars(f1);
    f2 = getMaxDollars(f2);
    f3 = getMaxDollars(f3);

    uint maxValue = std::max(f1 + f2 + f3, bc);
    maxDollars[bc] = maxValue;
    // cerr<<"getMaxDollars("<<bc<<") == "<<maxValue<<endl;

    return maxValue;
}

int
main()
{
    uint in;
    while (cin>>in)
    {
	cout<<getMaxDollars(in)<<endl;
    }

    /* 444492101 = 1800892710 */
}

//end of code

#include <cstdio>
#include <vector>
using namespace std;
// 0110100110010110
// 0 - 0
// 1 - 1
// 01 - 0
// 10 - 2
// 010 - 3
// 101 - 2
// 0101 - 10
// 1010 - 2

int p[4][2] = { {0,1}, {0,2}, {3,2}, {10,2} };

vector<vector<int> > s;
int code;
bool insert(int i, int val)
{
    s[i].push_back(val);
    int t = s[i].size();
    if(i<s.size()-1)
    {
        if((t+(code>>i))&1)
            return insert(i+1,val);
        return (val==s[i+1].back());
    }
    if(t>1 && s[i][t-1]==s[i][t-2])
    {
        s.push_back(vector<int>());
        if(t%2==0)
            code |= 1<<i;
        for(int j=0;j<t-1;j+=2)
            if(insert(i+1, s[i][j] == (t&1)))
                return true;
        return insert(i+1,val);
    }
    return false;
}
void tst()
{
    int n;
    scanf("%d",&n);
    s.clear();
    code = 0;
    bool wrong = false;
    s.push_back(vector<int>());
    for(int it=0;it<n;it++)
    {
        int x;
        scanf("%d",&x);
        if(wrong)
        {
            printf("-1 ");
            continue;
        }
        
        wrong = insert(0, x);

        if(s.back().size()>4)
            wrong = true;

        if(wrong)
        {
            printf("-1 ");
        }
        else
        {
            printf("%d ",code + (p[s.back().size()-1][s.back()[0]]<<(s.size()-1)));
        }
    }
    puts("");
}

int main()
{
    int t;
    scanf("%d",&t);
    for(;t--;)
        tst();
}
//end of code

#include<iostream>
#include<iomanip>
using namespace std;
main()
{int x,y;
float t;
cin>>x>>setprecision(2)>>y;
if(x%5==0)
{t=x;
if(t>y)
cout<<setprecision(2)<<y;
else
{t=t+.5;
y=y-t;
cout<<setprecision(2)<<y;
}
}
}
//end of code

#include<iostream>
#include<iomanip>
using namespace std;
main()
{int x,y;
float t;
cin>>x>>setprecision(2)>>y;
if(x%5==0)
{t=x;
if(t>y)
cout<<setprecision(2)<<y;
else
{t=t+.5;
y=y-t;
cout<<setprecision(2)<<y;
}
}
}
//end of code

l1
l2
l3		
l4
l5 l6
//end of code
l1
l2
l3
l3 l4
l5															l6				
//end of cod

public class Main
{
	public static void main(String[] args) throws java.io.Exception
	{
		int i,t;
		int arr[] = new int[100];
		
		java.io.BufferedReader br = new java.io.BufferedReader(new java.io.InputStreamReader(System.in));
		
		t= Integer.parseInt(br.readLine());
		
		for(i=0;i<t;i++)
		{
			arr[i]=Integer.parseInt(br.readLine());
		}

		for(i=0;i<t;i++)
		{
			System.out.println(factorial(arr[i]));

		}
	}
	static int factorial(int n)
	{
		if (n==0)
			return 1;
		else
			return (n*factorial(n-1));
	}
}

//end of code

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.text.DecimalFormat;

public class Main
{
    public static void main(String[] args) throws Exception
    {
        BufferedReader r = null;
        try
        {
            r = new BufferedReader(new InputStreamReader(System.in));
            String input = r.readLine().trim();
            String[] line = input.split(" ",2);
            short withdrawalAmount = Short.parseShort(line[0]);
            float remainingAmount = Float.parseFloat(line[1]) - (withdrawalAmount + 0.50f);
            if (remainingAmount >= 0 && withdrawalAmount % 5 == 0 )
            {
                System.out.printf("%.2f",remainingAmount);
            }
            else
            {
                System.out.printf("%.2f",line[1]);
            }
        }
        catch (Exception e)
        {
            throw new Exception("Number Expected");
        }
    }
}

//end of code

public class Main
{
    
  public static void main (String[] args) throws java.lang.Exception
   {  
     int arr[]=new int[100]; 
     factorial f = new factorial();
     java.io.BufferedReader r = new java.io.BufferedReader
     (new java.io.InputStreamReader (System.in));
     int n=Integer.parseInt(r.readLine());
     for (int i=1;i<=n;i++)
      {       
       arr[i]=Integer.parseInt(r.readLine());
      } 
     for (int i=1;i<=n;i++)
      {
       double fact=f.fact(arr[i]);
       System.out.println(fact);
      }
    }
}
public class factorial
{
  public  double fact(int a)
   {
     if(a==1) 
      {     
        return 1;
      }  
   double result=fact(a-1)*a;
     return(result);
   }   
}

//end of code
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.text.DecimalFormat;

public class Main
{
    public static void main(String[] args) throws Exception
    {
        BufferedReader r = null;
        try
        {
            r = new BufferedReader(new InputStreamReader(System.in));
            String input = r.readLine().trim();
            String[] line = input.split(" ",2);
            short withdrawalAmount = Short.parseShort(line[0]);
            float remainingAmount = Float.parseFloat(line[1]) - (withdrawalAmount + 0.50f);
            if (remainingAmount >= 0 && withdrawalAmount % 5 == 0 )
            {
                System.out.printf("%.2f",remainingAmount);
            }
            else
            {
                System.out.printf("%.2f",line[1]);
            }
        }
        catch (Exception e)
        {
            throw new Exception("Number Expected");
        }
    }
}

//end of code

cost, balance = [float(x) for x in sys.stdin.read().split()]
while (cost and balance):
    if (cost%5 != 0 or cost+.50 >= total):
        print "%.2f" % total
    else:
        result = total-cost-.50
        print "%.2f" % result
    cost, balance = [float(x) for x in sys.stdin.read().split()]
    
    cost, balance = [float(x) for x in sys.stdin.read().split()]
while (cost and balance):
    if (cost%5 != 0 or cost+.50 >= total):
        print "%.2f" % total
    else:
        result = total-cost-.50
        print "%.2f" % result
    cost, balance = [float(x) for x in sys.stdin.read().split()]
//end of code

#include<iostream.h>
#include<conio.h>
double fact(int a)
 {
  double f=1;
  for(int i=1;i<=a;i++)
  f*=i;
  return f;
 }

void main()
{
 clrscr();
 int j;
 cin>>j;
 int a[100];
 double fc[100];
 for(int i=0;i<j;i++)
 { 
   cin>>a[i];
   fc[i]=fact(a[i]);
 }
 for(i=0;i<j;i++)
 cout<<fc[i]<<endl;
}
//end of  code
#include<iostream.h>
#include<conio.h>
double fact(int a)
 {
  double f=1;
  for(int i=1;i<=a;i++)
  f*=i;
  return f;
 }

void main()
{
 clrscr();
 int j;
 cin>>j;
 int a[100];
 double fc[100];
 for(int i=0;i<j;i++)
 { 
   cin>>a[i];
   fc[i]=fact(a[i]);
 }
 for(i=0;i<j;i++)
 cout<<fc[i]<<endl;
}
//end of code

#include<iostream.h>
#include<conio.h>
double fact(int a)
 {
  double f=1;
  for(int i=1;i<=a;i++)
  f*=i;
  return f;
 }

void main()
{
 clrscr();
 int j;
 cin>>j;
 int a[100];
 double fc[100];
 for(int i=0;i<j;i++)
 { 
   cin>>a[i];
   fc[i]=fact(a[i]);
 }
 for(i=0;i<j;i++)
 cout<<fc[i]<<endl;
}
#include<iostream.h>
#include<conio.h>
double fact(int a)
 {
  double f=1;
  for(int i=1;i<=a;i++)
  f*=i;
  return f;
 }

void main()
{
 clrscr();
 int j;
 cin>>j;
 int a[100];
 double fc[100];
 for(int i=0;i<j;i++)
 { 
   cin>>a[i];
   fc[i]=fact(a[i]);
 }
 for(i=0;i<j;i++)
 cout<<fc[i]<<endl;
}
#include<iostream.h>
#include<conio.h>
double fact(int a)
 {
  double f=1;
  for(int i=1;i<=a;i++)
  f*=i;
  return f;
 }

void main()
{
 clrscr();
 int j;
 cin>>j;
 int a[100];
 double fc[100];
 for(int i=0;i<j;i++)
 { 
   cin>>a[i];
   fc[i]=fact(a[i]);
 }
 for(i=0;i<j;i++)
 cout<<fc[i]<<endl;
}
//end of code

def main():
  max = int(raw_input());
  arr = [];
  i = 0;

  while i < max:
    arr.append(fact(int(raw_input())));
    i += 1;
    
  for res in arr:
    print res;

def fact(x):
  result = 1;
  
  while x > 1:
    result *= x;
    x -= 1;

  return result;

if __name__ == '__main__':
  main();
  
//end of code
<?php
$output = array();
$num_input = trim(fgets(STDIN));
if( $num_input > 20 )
	exit;
$num_points_per_input = array();
$input_points = array();
for( $i=0; $i<$num_input; $i++ )
{
	$output[$i] = 0;
	$num_points_per_input =trim(fgets(STDIN));
	if( $num_points_per_input < 2 || $num_points_per_input > 100000)
		continue;
	$input_points[$i] = array();
	for( $j=0; $j<$num_points_per_input; $j++ )
	{
		 $data =explode(' ',trim(fgets(STDIN)));
		 if( count( $data ) == 2 )
		 {
		 	$input_points[$i][$data[0]][] = $data[1];
		 }
	}
	$output[$i] = calculateData( $input_points[$i] );
}

function calculateData( $points_for_input )
{
	$point_length = 0;
	$first_exec = true;
	$last_x = 0;
	$last_y = 0;
	ksort($points_for_input, SORT_NUMERIC);
	foreach ( $points_for_input as $key=>$value )
	{
		if( $first_exec == true )
		{
			$first_exec = false;
			$point_length = max( $value ) - min($value);
			$last_y= min($value);
		}
		else
		{
			rsort( $value, SORT_NUMERIC );
			$point_length = $point_length +  sqrt( (($value[0]-$last_y)*($value[0]-$last_y)) + (($key-$last_x)*($key-$last_x)) );
			$point_length = $point_length + ( $value[0] - $value[count($value)-1]);
			$last_y = max( $value );
		}
		$last_x = $key;
	}
	return $point_length;
}
foreach ($output as $value) {
 fwrite(STDOUT, round($value, 2)."\n");
}
exit(0);
?>
//end of code

public class Main {
	public static void main(String[] args) throws Exception{
		java.io.BufferedReader r = new java.io.BufferedReader
		(new java.io.InputStreamReader (System.in));
		int noOfTestCases = Integer.parseInt(r.readLine());
		for(int i=0;i<noOfTestCases;i++){
			r.readLine();
			String mn = r.readLine();
			m = Integer.parseInt(mn.split(" ")[0]);
			n = Integer.parseInt(mn.split(" ")[1]);
			board = new int[m][n];
			for(int x=0;x<m;x++){
				String allN[] = r.readLine().split(" ");
				for(int y=0;y<n;y++){
					board[x][y]=Integer.parseInt(allN[y]);
				}
			}
			System.out.println(calculateMaxMoves(board));
		}
	}
	
	static int [][]board;
	static int m;
	static int n;
	
	public static int calculateMaxMoves(int [][]board){
		int moves[][]=new int[m][n];
		int highest=0;
		for(int i=m-1;i>=0;i--)
			for(int j=n-1;j>=0;j--){
				moves[i][j]=1;
				int colMax=0;
				int colLeader=Integer.MAX_VALUE;
				for(int col=j+1;col<n;col++)
					if(board[i][col]>=board[i][j] && board[i][col]<colLeader){
						int currMoves=moves[i][col];
						colLeader=board[i][col];
						if(currMoves>colMax)
							colMax=currMoves;
						if(colLeader==board[i][j])
							break;							
					}					
				int rowMax=0;
				int rowLeader=-1;
				for(int row=i+1;row<m;row++)
					if(board[row][j]<=board[i][j] && board[row][j]>rowLeader){
						int currMoves=moves[row][j];
						rowLeader=board[row][j];
						if(currMoves>rowMax)
							rowMax=currMoves;
						if(rowLeader==board[i][j])
							break;
					}
				moves[i][j]+=(Math.max(colMax,rowMax));
				if(moves[i][j]>highest)
					highest=moves[i][j];
			}		
		return highest;
	}
}
//end of code
#include <iostream>
//end of code

#include<stdio.h>
//#include<stdlib.h>
//#include<alloc.h>

#define N 5
int main()
{
    int a;
    int i,j;
    printf("Enter the series\n");
   // a=(int *)malloc(10*sizeof(int));
    while(1)
    {
                 scanf("%d",&a);
                 printf("\n");
                 if(a==42)
                        
                    break;

                    else
                        printf("\n%d",a);
                 }             
    
    
    getchar();
    return 0; 
}           

//end of code

YOU ARE A BAD GUY
//end of code

1; 2; 3; 4; 5;
//end of code
1; 2; 3; 4;
//end of code1
4; 5;

//end of code

#include<iostream>
#include<stdlib.h>
#include<math.h>
using namespace std;

int main()
{
	int *prime,nprime,		upto=31625; //=sqrt(10^9)
	prime=(int*)malloc(3410*sizeof(int));
	prime[0]=2;	prime[1]=3;	prime[2]=5;	prime[3]=7;
	unsigned long iz,bz;	int jz,kz,az;

	kz=nprime=4;	iz=az=10;	bz=az*az;
	while(iz< upto )
		{for(iz=az;iz<bz && iz< upto ;iz++)
			{for(jz=0;jz<kz && iz%prime[jz]!=0 ;jz++);
			
	if(jz==kz)	prime[nprime++]=iz;	//cout<<iz<<" ";}
			}
		az=bz;	bz=az*az;	kz=nprime;
		}
	//cout<<"\nnprime = "<<nprime;	cin>>az;

	unsigned int tc,b;
	long m,n,i,j,a;	char *x;

	cin>>tc;
	while(tc--)
	{
		cin>>m>>n;
		if(m==1)	m+=1;
		x=(char*)malloc(n-m+10);
		for(i=0;i<(n-m+1); x[i]=0 ,i++);
		b=pow(n,.5);
		for(i=0; prime[i]<=b ;i++)
		{
			if(prime[i]==0) continue;
			a=m/prime[i];
			if(m%prime[i]!=0)	a+=1;
			a=a*prime[i];
			if(prime[i]>=m) a+=prime[i];

			for(j=a;j<=n; x[j-m]=1, j+=prime[i]);
		}
		a=0;
		for(i=0;i<(n-m+1);i++)
			if(x[i]==0) {a+=1;	cout<<(m+i)<<"\n";}
		//cout<<"\n::"<<a;
	}

	return 0;

}
//end of code
